#pragma semicolon 1

#include <sourcemod>
#include <sdktools>

#define PLUGIN_VERSION "3.1"
#define MAX_PLAYERS 64
#define MAXFILE 50

#define DMG_GENERIC			0

enum Model
{
	String:Basemodels[256],
	String:Headlessmodels[256],
	String:Headmodels[256],
}
new ModelFile[MAXFILE][Model];
new Num;

// decap cvars
new Handle:cvDecapHeadshot = INVALID_HANDLE;
new Handle:cvDecapThreshold = INVALID_HANDLE;
new Handle:cvDecapKnifeCritDmg = INVALID_HANDLE;
new Handle:cvDecapKnifeCrit = INVALID_HANDLE;

new Handle:cvDecapShake = INVALID_HANDLE;
new Handle:cvDecapFov = INVALID_HANDLE;
new Handle:cvDecapFovNum = INVALID_HANDLE;
new Handle:cvDecapFX = INVALID_HANDLE;
new Handle:cvDecapSound = INVALID_HANDLE;
new Handle:cvDecapSoundPath = INVALID_HANDLE;
new Handle:cvDecapSoundPathCrit = INVALID_HANDLE;

new Handle:cvDecapMaxHeads = INVALID_HANDLE;

//Sounds
new String:soundPath[PLATFORM_MAX_PATH];
new String:soundPathCrit[PLATFORM_MAX_PATH];

int maxHeads;
new Handle:headsQuerry;

public Plugin:myinfo = 
{
	name = "ZombieDecapitation",
	author = "Koduua & RuFa, .robot, msi morkva, Scarface_slv",
	description = "Cut off player's head",
	version = PLUGIN_VERSION,
	url = ""
};

public OnPluginStart()
{
	CreateConVar("sm_decap_version", PLUGIN_VERSION, "ZombieDecapitation Version", FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY|FCVAR_DONTRECORD);

	cvDecapHeadshot = CreateConVar("sm_decap_headshot", "1", "Enable/Disable headshot decapitation", _, true, 0.0, true, 1.0);

	cvDecapThreshold = CreateConVar( "sm_decap_threshold", "2000", "Player's HP must be less or equal for decapitation (except knife crit)");

	cvDecapKnifeCrit = CreateConVar( "sm_decap_knife_crit", "1", "Enable/Disable critical hit with knife (instant decapitation)", _, true, 0.0, true, 1.0);
	cvDecapKnifeCritDmg = CreateConVar( "sm_decap_knife_crit_dmg", "3000", "Knife critical hit damage");

	cvDecapShake = CreateConVar("sm_decap_shake", "1", "Enable/Disable victim's screen shaking after decapitation", _, true, 0.0, true, 1.0);
	cvDecapFov = CreateConVar("sm_decap_fov", "1", "Enable/Disable victim's FOV change after decapitation", _, true, 0.0, true, 1.0);
	cvDecapFovNum = CreateConVar("sm_decap_fov_num", "120", "FOV for decapitated players");
	cvDecapFX = CreateConVar("sm_decap_fx", "1", "Enable/Disable blood particle effect", _, true, 0.0, true, 1.0);
	cvDecapSound = CreateConVar("sm_decap_sound", "1", "Enable/Disable decapitation sound", _, true, 0.0, true, 1.0);
	cvDecapSoundPath = CreateConVar("sm_decap_soundpath", "misc/decapitation/headshot.mp3", "Sound path");
	cvDecapSoundPathCrit = CreateConVar("sm_decap_soundpath_crit", "misc/decapitation/crit.mp3", "Sound path for decapitation with knife");

	cvDecapMaxHeads = CreateConVar("sm_decap_max_heads", "8", "Maximum number of head props");

	AutoExecConfig(true,"ZombieDecapitation");

	HookEvent("player_hurt", EventPlayerHurt, EventHookMode_Pre);
	HookEvent("round_start", Event_RoundStart);

	headsQuerry = CreateArray(1, 0);
}

public OnEventShutdown()
{
	UnhookEvent("player_hurt", EventPlayerHurt, EventHookMode_Pre);
}

public OnMapStart()
{
	//Precache particle
	AddFileToDownloadsTable("particles/decapitation_blood1.pcf");
	PrecacheGeneric("particles/decapitation_blood1.pcf", true);
	PrecacheEffect("ParticleEffect");
	PrecacheParticleEffect("decapitation_blood1");

	//Precache sounds
	GetConVarString(cvDecapSoundPathCrit, soundPathCrit, sizeof(soundPathCrit));
	GetConVarString(cvDecapSoundPath, soundPath, sizeof(soundPath));
	decl String:downloadSoundCrit[PLATFORM_MAX_PATH];
	decl String:downloadSound[PLATFORM_MAX_PATH];
	Format(downloadSoundCrit, sizeof(downloadSoundCrit), "sound/%s", soundPathCrit);
	Format(downloadSound, sizeof(downloadSound), "sound/%s", soundPath);
	AddFileToDownloadsTable(downloadSoundCrit);
	AddFileToDownloadsTable(downloadSound);
	PrecacheSound(soundPathCrit);
	PrecacheSound(soundPath);

	//Pracache models
	Num = 0;
	new Handle:kv = CreateKeyValues("Models");
	FileToKeyValues(kv, "cfg/sourcemod/ZombieDecapitation_models.txt");        
	if (KvGotoFirstSubKey(kv))
	{
		do
		{
			KvGetString(kv, "basemodel", ModelFile[Num][Basemodels], 255);
			KvGetString(kv, "headlessmodel", ModelFile[Num][Headlessmodels], 255);
			KvGetString(kv, "headmodel", ModelFile[Num][Headmodels], 255);
			++Num;
		}
		while (KvGotoNextKey(kv));
	}
	for(new i=0; i<Num; i++) 
	{
		AddFileToDownloadsTable(ModelFile[i][Basemodels]);
		AddFileToDownloadsTable(ModelFile[i][Headlessmodels]);
		AddFileToDownloadsTable(ModelFile[i][Headmodels]);
		PrecacheModel(ModelFile[i][Basemodels],true);
		PrecacheModel(ModelFile[i][Headlessmodels],true);
		PrecacheModel(ModelFile[i][Headmodels],true);
	}
}

public Event_RoundStart(Handle:event, const String:name[], bool:dontBroadcast)
{
	ClearArray(headsQuerry);
}

public Action:EventPlayerHurt(Handle:event, const String:name[], bool:dontBroadcast)
{	
	new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	new victim = GetClientOfUserId(GetEventInt(event, "userid"));

	if ((!IsValidClient(attacker)) || (!IsValidClient(victim)))
		return Plugin_Continue;

	new hitgroup = GetEventInt(event, "hitgroup");
	new bool:doDecap = false;
	new bool:crit = false;
	new victim_health = GetClientHealth(victim);
	new String:weapon[64];
	GetEventString(event, "weapon", weapon, 64);

	if (victim_health <= GetConVarInt(cvDecapThreshold))
	{
		if ((hitgroup == 1) && (GetConVarBool(cvDecapHeadshot)))
			doDecap = true;
		else if (IsKnifeClass(weapon) || (StrEqual(weapon, "hegrenade", false)))
				doDecap = true;
	}
	else if (IsKnifeClass(weapon) && (GetConVarBool(cvDecapKnifeCrit)))
	{
		doDecap = true;
		crit = true;
	}
	else return Plugin_Continue;

	if (doDecap)
	{
			new String:basemodel[256];
			new String:headlessmodel[256];
			new String:headmodel[256];
			GetClientModel(victim, basemodel, 256);
			new bool:doDecapModel = false;
			for(new i=0; i<Num; i++)
			{
				if(StrEqual(basemodel, ModelFile[i][Basemodels], false))
				{
					strcopy(headlessmodel, sizeof(headlessmodel), ModelFile[i][Headlessmodels]);
					strcopy(headmodel, sizeof(headmodel), ModelFile[i][Headmodels]);
					doDecapModel = true;
					break;
				}
			}

			if(IsModelPrecached(headlessmodel) && IsModelPrecached(headmodel) && doDecapModel)
			{
				SetEntityModel(victim, headlessmodel);
				GiveHead(victim, headmodel);

				//Shake
				if(GetConVarBool(cvDecapShake))
					VEffectsShakeClientScreen(victim, 30.0, 1.5, 5.0);

				//FOV
				if(GetConVarBool(cvDecapFov))
					SetEntProp(victim, Prop_Send, "m_iFOV", GetConVarInt(cvDecapFovNum));

				//Sound
				if (GetConVarBool(cvDecapSound))
				{
					if (IsKnifeClass(weapon))
					 {
					 	EmitSoundToAll(soundPathCrit, victim, _, 140);
					 } else {
					 	EmitSoundToAll(soundPath, victim, _, 140);
					 }
				}

				//Crit
				if(crit)
					DealDamage(victim,GetConVarInt(cvDecapKnifeCritDmg),attacker,DMG_GENERIC,"knife");

				//FX
				if(GetConVarBool(cvDecapFX))
					AttachParticle(victim, "decapitation_blood1");
			}
	}
	return Plugin_Continue;
}

public GiveHead(any:victim, String:headmodel[])
{
	new headEnt = CreateEntityByName("prop_physics_override");
	SetEntityModel(headEnt,headmodel);
	SetEntityMoveType(headEnt, MOVETYPE_VPHYSICS);
	SetEntProp(headEnt, Prop_Data, "m_CollisionGroup", 11);
	DispatchSpawn(headEnt);

	if(IsValidEntity(headEnt) && IsValidEdict(headEnt))
	{
		maxHeads = GetConVarInt(cvDecapMaxHeads);

		new Float:Client_Origin[3];
		new Float:Client_Angles[3];
		new Float:vecVelocity[3];

		GetClientAbsOrigin(victim,Client_Origin);
		GetClientAbsAngles(victim,Client_Angles);

		Client_Origin[2] += 50;

		vecVelocity[0] = GetRandomFloat(-130.0,130.0);
		vecVelocity[1] = GetRandomFloat(-130.0,130.0);
		vecVelocity[2] = GetRandomFloat(150.0,400.0);
		
		TeleportEntity(headEnt, Client_Origin, Client_Angles, vecVelocity);

		PushArrayCell(headsQuerry, headEnt);

		if(GetArraySize(headsQuerry) > maxHeads)
		{
			new headToDissolve = GetArrayCell(headsQuerry, 0);
			Dissolve(headToDissolve);
			RemoveFromArray(headsQuerry, 0);
		}
	}
}

DealDamage(victim,damage,attacker,dmg_type=DMG_GENERIC,String:weapon[]="")
{
	if(IsValidClient(victim) && IsPlayerAlive(victim) && damage>0)
	{
		new String:dmg_str[16];
		IntToString(damage,dmg_str,16);
		new String:dmg_type_str[32];
		IntToString(dmg_type,dmg_type_str,32);
		new pointHurt=CreateEntityByName("point_hurt");
		if(pointHurt)
		{
			DispatchKeyValue(victim,"targetname","hurtme");
			DispatchKeyValue(pointHurt,"DamageTarget","hurtme");
			DispatchKeyValue(pointHurt,"Damage",dmg_str);
			DispatchKeyValue(pointHurt,"DamageType",dmg_type_str);
			if(!StrEqual(weapon,""))
				DispatchKeyValue(pointHurt,"classname",weapon);
			DispatchSpawn(pointHurt);
			AcceptEntityInput(pointHurt,"Hurt",(attacker>0)?attacker:-1);
			DispatchKeyValue(pointHurt,"classname","point_hurt");
			DispatchKeyValue(victim,"targetname","donthurtme");
			//RemoveEdict(pointHurt);
			AcceptEntityInput(pointHurt, "Kill");
		}
	}
}

public VEffectsShakeClientScreen(client, Float:amplitude, Float:frequency, Float:duration)
{
    new Handle:hShake = StartMessageOne("Shake", client);
    
    // Validate.
    if (hShake == INVALID_HANDLE)
    {
        return;
    }
    
    if (GetUserMessageType() == UM_Protobuf)
    {
        PbSetInt(hShake, "command", 0);
        PbSetFloat(hShake, "local_amplitude", amplitude);
        PbSetFloat(hShake, "frequency", frequency);
        PbSetFloat(hShake, "duration", duration);
    }
    else
    {
        BfWriteByte(hShake, 0);
        BfWriteFloat(hShake, amplitude);
        BfWriteFloat(hShake, frequency);
        BfWriteFloat(hShake, duration);
    }
	
    // End usermsg and send to client.
    EndMessage();
}

AttachParticle(client, String:particleType[])
{
	new particle=CreateEntityByName("info_particle_system");
	SetEntPropEnt(particle, Prop_Data, "m_hOwnerEntity", client);
	DispatchKeyValue(particle, "effect_name", particleType);
	SetVariantString("!activator");
	AcceptEntityInput(particle, "SetParent", client, particle, 0);
	SetVariantString("facemask");
	AcceptEntityInput(particle, "SetParentAttachment", particle , particle, 0);
	DispatchSpawn(particle);
	
	AcceptEntityInput(particle, "start");
	ActivateEntity(particle);
	
	CreateTimer(10.0, DeleteParticle, particle);
}

public Action:DeleteParticle(Handle:Timer, any:particle)
{
	if(IsValidEntity(particle))
	{
		new String:classname[256];
		GetEdictClassname(particle, classname, sizeof(classname));
		if (StrEqual(classname, "info_particle_system", false))
		{
			AcceptEntityInput(particle, "Stop");
			AcceptEntityInput(particle, "Kill");
		}
	}
}

Dissolve(any:entity)
{
	if(entity > 0 && IsValidEdict(entity) && IsValidEntity(entity))
	{
		new g_iDissolve = CreateEntityByName("env_entity_dissolver");
		if(g_iDissolve > 0)
		{
			decl String:g_sName[32];
			Format(g_sName, sizeof(g_sName), "dis_%d", entity);

			DispatchKeyValue(entity, "targetname", g_sName);
			DispatchKeyValue(g_iDissolve, "target", g_sName);
			DispatchKeyValue(g_iDissolve, "dissolvetype", "2");
			AcceptEntityInput(g_iDissolve, "Dissolve");
			AcceptEntityInput(g_iDissolve, "Kill");
		}
		else
			AcceptEntityInput(entity, "Kill");
	}
}

stock void PrecacheEffect(const char[] sEffectName)
{
    static int table = INVALID_STRING_TABLE;
    
    if (table == INVALID_STRING_TABLE)
    {
        table = FindStringTable("EffectDispatch");
    }
    bool save = LockStringTables(false);
    AddToStringTable(table, sEffectName);
    LockStringTables(save);
}

stock void PrecacheParticleEffect(const char[] sEffectName)
{
    static int table = INVALID_STRING_TABLE;
    
    if (table == INVALID_STRING_TABLE)
    {
        table = FindStringTable("ParticleEffectNames");
    }
    bool save = LockStringTables(false);
    AddToStringTable(table, sEffectName);
    LockStringTables(save);
}

stock bool:IsKnifeClass(const String:classname[])
{
	if(StrContains(classname, "knife") != -1 || StrContains(classname, "bayonet") > -1)
		return true;
	return false;
}

stock bool:IsValidClient(client, bool:nobots = false)
{ 
    if (client <= 0 || client > MaxClients || !IsClientConnected(client) || (nobots && IsFakeClient(client)))
    {
        return false; 
    }
    return IsClientInGame(client);
}